
/*
 *  project  ontic
 *
 */

#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

#define  UNKNOWN        -1
#define  LIB1           1
#define  LIB2           2
#define  PUBLIB         3
#define  NOWHERE        -2
#define  EVERYFUNCTION  -3

struct LabelList {
   char      *Item;
   LabelList *next;
   int       Position;          // In which library is this function
   int       Variable;          // Indicates, if this label a variable is
   int       LibIndex;
};

// The following class reads an assembler file and generates a labeltree
class ReadASM {
public:
   ReadASM (char *file, char *IndependendLibs[], int DoorsOS);

   int Solve (ReadASM *OtherLibs[]);

   int WritePositions (ofstream& OFile, int Lib);
   int WriteDefinitions (ofstream& OFile, int Lib, int& Number);
   int WriteFunctions (ofstream& OFile, int Lib, ReadASM *il[]);

   int GetFunctions   ();
   int MovedFunctions (int Lib);

   inline int Second_Pass ()
   {
      SecondPass = 1;
   } // Second_Pass

   inline int AreYouCMAIN ()
   {
      return strncmp (FileName, "cmain", 5) == 0;
   } // AreYouCMAIN

   ~ReadASM ();
protected:
   LabelList *start, *last;
   char      FileName[32];
   int       Independend, DoorsPRGM;
   int       SecondPass;     // Used to generate the publib init code
};
